#include <stdarg.h>
#include <openssl/md5.h>

#include "md5.h"

static int _md5_calc(unsigned char *digest, int num, va_list ap)
{
  int i, size;
  char *data;
  MD5_CTX context;

  MD5_Init(&context);
  for (i = 0; i < num; i++) {
    data = va_arg(ap, char *);
    size = va_arg(ap, int);
    MD5_Update(&context, data, size);
  }
  MD5_Final(digest, &context);

  return 0;
}

int md5_calc(unsigned char *digest, int num, ...)
{
  va_list arg;
  int done;

  va_start(arg, num);
  done = _md5_calc(digest, num, arg);
  va_end(arg);

  return done;
}
